; #########################################################################

    .386
    .model flat, stdcall      ; 32 bit memory model
    option casemap :none      ; case sensitive

    include calc.inc          ; local includes for this file

    .data

    szTest db "Testing "
    szBuf  db 100 dup (0)
    hzRect  RECT <30,20,300,80>

    .code

XX  MACRO sym, x, y, w, h, color, func

        func proc hWin:DWORD, hKey:DWORD
            invoke szCopy, hKey, ADDR szBuf
            invoke InvalidateRect, hWin, ADDR hzRect, TRUE
            invoke UpdateWindow, hWin
            ret
        func endp

    ENDM

    geometry

; #########################################################################

    .data

    szDisplayName db "Calculator Template",0
    CommandLine dd 0
    hInstance   dd 0
    hWnd        dd 0

key STRUCT
    sym   db 8 dup (0)
    x     dd 0
    y     dd 0
    w     dd 0
    h     dd 0
    color dd 0
    func  dd 0
key ENDS

XX  MACRO s, x, y, w, h, c, fn
    key  <s, x, y, w, h, c, fn>
    ENDM

table equ $
    geometry
tablelim equ $

    .code

start:

    invoke GetModuleHandle, NULL
    mov hInstance, eax

    invoke GetCommandLine
    mov CommandLine, eax

    invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
    invoke ExitProcess,eax

; #########################################################################

WinMain proc hInst     :DWORD,
             hPrevInst :DWORD,
             CmdLine   :DWORD,
             CmdShow   :DWORD

    ;====================
    ; Put LOCALs on stack
    ;====================

    LOCAL wc      :WNDCLASSEX
    LOCAL msg     :MSG
    LOCAL Wwd     :DWORD
    LOCAL Wht     :DWORD
    LOCAL Wtx     :DWORD
    LOCAL Wty     :DWORD
    LOCAL hBitmap :DWORD
    LOCAL hBrush  :DWORD

    ;==================================================
    ; Fill WNDCLASSEX structure with required variables
    ;==================================================

    szText szClassName,"Calculator_Template_Class"

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNWINDOW
    mov wc.lpfnWndProc,    offset WndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInst
    invoke BitmapFromResource, hInstance, 2000
    mov hBitmap, eax
    invoke CreatePatternBrush, eax
    mov hBrush, eax
    mov wc.hbrBackground, eax
    mov wc.lpszMenuName,   NULL
    mov wc.lpszClassName,  offset szClassName
    invoke LoadIcon,hInst,1
    mov wc.hIcon,          eax
    mov wc.hIconSm,        eax
    invoke LoadCursor,NULL,IDC_ARROW
    mov wc.hCursor,        eax

    invoke RegisterClassEx, ADDR wc

    ;================================
    ; Centre window at following size
    ;================================

    mov Wwd, BMWIDTH+5          ; bitmap width + 5 for window frame
    mov Wht, BMHEIGHT+31        ; bitmap height + 31 for title and frame

    invoke GetSystemMetrics,SM_CXSCREEN
    invoke TopXY,Wwd,eax
    mov Wtx, eax

    invoke GetSystemMetrics,SM_CYSCREEN
    invoke TopXY,Wht,eax
    mov Wty, eax

    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPED or WS_SYSMENU,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInst,NULL
    mov   hWnd,eax

    invoke LoadMenu,hInst,600  ; menu ID
    invoke SetMenu,hWnd,eax

    invoke ShowWindow,hWnd,SW_SHOWNORMAL
    invoke UpdateWindow,hWnd

    ;===================================
    ; Loop until PostQuitMessage is sent
    ;===================================

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp StartLoop
    ExitLoop:

    invoke DeleteObject, hBitmap
    invoke DeleteObject, hBrush

    return msg.wParam

WinMain endp

; #########################################################################

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL hStatImage :DWORD
    LOCAL hBmp   :DWORD
    LOCAL Rct    :RECT
    LOCAL hDC    :DWORD
    LOCAL Ps     :PAINTSTRUCT
    LOCAL buffer1[128]:BYTE  ; these are two spare buffers
    LOCAL buffer2[128]:BYTE  ; for text manipulation etc..

    .if uMsg == WM_COMMAND

        .if wParam == 400

        .endif

    .elseif uMsg == WM_LBUTTONDOWN
        invoke LButtonDown,hWin,uMsg,wParam,lParam
        return 0
    .elseif uMsg == WM_LBUTTONUP
        invoke LButtonUp,hWin,uMsg,wParam,lParam
        return 0
    .elseif uMsg == WM_RBUTTONDOWN
    .elseif uMsg == WM_RBUTTONUP
    .elseif uMsg == WM_CREATE
    .elseif uMsg == WM_SIZE
    .elseif uMsg == WM_PAINT
        invoke BeginPaint,hWin,ADDR Ps
        mov hDC, eax
        invoke Paint_Proc,hWin,hDC
        invoke EndPaint,hWin,ADDR Ps
        return 0
    .elseif uMsg == WM_CLOSE
    .elseif uMsg == WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0 
    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

FindMsgKey proc hWin:DWORD

    LOCAL pos:POINT
    LOCAL msgpos:DWORD
    LOCAL msgbuf[128]:BYTE

    invoke GetMessagePos
    mov msgpos, eax
    mov ecx, eax
    and eax, 0FFFFh
    shr ecx, 16
    mov pos.x, eax
    mov pos.y, ecx
    invoke ScreenToClient,hWin,ADDR pos

    mov eax, offset table
@@: mov ecx, (key PTR [eax]).x
    mov edx, pos.x
    cmp ecx, edx
    jae next
    add ecx, (key PTR [eax]).w
    cmp ecx, edx
    jbe next

    mov ecx, (key PTR [eax]).y
    mov edx, pos.y
    cmp ecx, edx
    jae next
    add ecx, (key PTR [eax]).h
    cmp ecx, edx
    jbe next

    return eax

next:
    add eax, SIZEOF(key)
    cmp eax, tablelim
    jb @B

    szText btnFoundFmt,"at %d, %d"

    invoke wsprintf, ADDR szBuf, ADDR btnFoundFmt, pos.x, pos.y
    invoke InvalidateRect, hWin, ADDR hzRect, TRUE

    return 0

FindMsgKey endp


LButtonDown proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    ret

LButtonDown endp

LButtonUp proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    invoke FindMsgKey, hWin

    .if eax!=0
      mov ecx,(key PTR [eax]).func
      push eax
      push hWin
      call ecx
      add esp,8
    .endif

    ret

LButtonUp endp

; ########################################################################

TopXY proc wDim:DWORD, sDim:DWORD

    shr sDim, 1      ; divide screen dimension by 2
    shr wDim, 1      ; divide window dimension by 2
    mov eax, wDim    ; copy window dimension into eax
    sub sDim, eax    ; sub half win dimension from half screen dimension

    return sDim

TopXY endp

; #########################################################################

Paint_Proc proc hWin:DWORD, hDC:DWORD

  invoke SetBkMode,hDC,TRANSPARENT 
  invoke szLen, ADDR szTest
  invoke TextOut,hDC, 30, 20, ADDR szTest, eax

  return 0

Paint_Proc endp

end start
